SystemOrganization addCategory: #TusLibros!

Object subclass: #Carrito
	instanceVariableNames: 'catalogo canasto'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Carrito class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:58'!
invalidElementError
	self error: self invalidElementMessage.! !

!Carrito class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 21:22'!
invalidElementMessage
	^'No se puede agregar algo que no pertenece al catalogo'.! !

!Carrito class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 21:17'!
newWithThisCatalog: aCatalog
	^self new initializeWith: aCatalog. ! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:55'!
add: unElemento
	
	self add: 1 of: unElemento.
! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/3/2013 18:41'!
add: aSmallInteger of: anObject 
	catalogo at: anObject  ifAbsent:  [self class invalidElementError].
	"(catalogo includes: anObject) ifFalse: [self class invalidElementError]."
	canasto add: anObject  withOccurrences: aSmallInteger.! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:43'!
amountOf: anObject 
	^canasto occurrencesOf: anObject .! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'ebastian 6/3/2013 20:20'!
catalog
	^catalogo.! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:41'!
includes: anObject 
	^canasto includes: anObject .! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 21:18'!
initialize 
	canasto := Bag new.

	^self.! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 21:18'!
initializeWith: aCatalog 
	
	catalogo := aCatalog .
	^self.! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:35'!
isEmpty
	^canasto isEmpty.! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/4/2013 19:32'!
products
	^canasto.! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:49'!
size
	^canasto size.! !

Object subclass: #Cashier
	instanceVariableNames: 'dateToday salesBook merchantProcesor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cashier class methodsFor: 'error handling' stamp: 'SebastianGarbi 6/5/2013 18:34'!
CreditCardStolenMessage
	^'Tarjeta estolen cal de police '.! !

!Cashier class methodsFor: 'error handling' stamp: 'SebastianGarbi 6/5/2013 18:48'!
CreditCardWithoutMoneyMessage
	^'No hay money'.! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/3/2013 18:38'!
invalidCreditCardMessage
	^'La tarjeta no sirve!!!!   pobre'.! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'ebastian 6/3/2013 21:03'!
newWithThisDate: aDate andThisSalesBook: aSalesBook
	^self new initializeWith: aDate andThisSalesBook: aSalesBook.! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'ebastian 6/2/2013 14:41'!
noProductsInCartMessage
	^'No hay productos en el carrito para vender'.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/4/2013 20:04'!
calculateCartValue: aCart 
	| total |
	total := 0.
	aCart products do: [ :aProduct | total:= total + ( aCart catalog at: aProduct )].
	^total.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'ebastian 6/3/2013 21:04'!
initializeWith: aDate andThisSalesBook: aSalesBook.
	dateToday := aDate. 
	salesBook := aSalesBook.
	^self.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'ebastian 6/3/2013 20:15'!
isThisAValidCC: aCC 
	^((aCC owner ~= '')  and: (aCC creditCardNumber > 0)) and: (aCC expiration  >= dateToday month ).! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'ebastian 6/3/2013 21:09'!
salesBook
	^ salesBook! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/4/2013 19:56'!
sellProducts: aCart withThisCreditCard: aCC withThisMP: aMerchantProcessor
	
	(aCart isEmpty ) ifTrue: [self error: Cashier noProductsInCartMessage].
	(self isThisAValidCC:  aCC  ) ifFalse: [ self error: Cashier invalidCreditCardMessage ].
	aMerchantProcessor debitFrom: aCC amount: (self calculateCartValue: aCart ).
	salesBook add: (self calculateCartValue: aCart).
	
	"hay que seguir"! !

Object subclass: #CreditCard
	instanceVariableNames: 'owner creditCardNumber expiration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!CreditCard class methodsFor: 'as yet unclassified' stamp: 'ebastian 5/30/2013 22:05'!
newName: aByteString ccNumber: aSmallInteger expiration: month 
	^self new initializeWithName: aByteString ccNumber: aSmallInteger expiration: month.! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'ebastian 6/2/2013 12:54'!
creditCardNumber
	^ creditCardNumber.! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'ebastian 5/30/2013 22:59'!
expiration
	
	^ expiration! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'ebastian 6/2/2013 12:55'!
initializeWithName: aByteString ccNumber: aSmallInteger expiration: month 
	owner := aByteString.
	creditCardNumber := aSmallInteger.
	expiration := month.
	^self.! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'ebastian 6/2/2013 12:54'!
owner
	^owner.! !

TestCase subclass: #EditorialTest
	instanceVariableNames: 'debitExcecutionBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!EditorialTest methodsFor: 'carritoIntansce' stamp: 'SebastianGarbi 6/3/2013 18:48'!
carrito
	|catalogo|
	catalogo := self catalog .
	catalogo at: self libro put: 12.
	^Carrito newWithThisCatalog: catalogo.
	! !

!EditorialTest methodsFor: 'carritoIntansce' stamp: 'SebastianGarbi 5/29/2013 21:26'!
carrito: unCatalogo
	^Carrito newWithThisCatalog: unCatalogo.
	! !

!EditorialTest methodsFor: 'as yet unclassified' stamp: 'ebastian 6/3/2013 21:06'!
cashier: aDate 
	^Cashier newWithThisDate:  aDate andThisSalesBook: OrderedCollection new.! !

!EditorialTest methodsFor: 'catalogInstances' stamp: 'SebastianGarbi 6/3/2013 18:43'!
catalog
	^Dictionary new.! !

!EditorialTest methodsFor: 'merchantProcessorSimulator' stamp: 'SebastianGarbi 6/5/2013 18:46'!
debitFrom: aCreditCard amount: aSmallInteger 
	^debitExcecutionBlock value: aCreditCard value: aSmallInteger.! !

!EditorialTest methodsFor: 'catalogInstances' stamp: 'ebastian 5/30/2013 21:39'!
emptyCatalog
	^Dictionary new.! !

!EditorialTest methodsFor: 'libroinstances' stamp: 'ebastian 6/3/2013 20:27'!
libro
	^'Libro1'.! !

!EditorialTest methodsFor: 'libroinstances' stamp: 'ebastian 6/3/2013 20:27'!
libroDeOtroCatalogo
	^'Libro2'.! !

!EditorialTest methodsFor: 'merchantProcessorSimulator' stamp: 'SebastianGarbi 6/5/2013 18:51'!
merchantProcesorFail
	debitExcecutionBlock := [ :aCC :anAmount |
		self fail.
		] .
	^self
	! !

!EditorialTest methodsFor: 'merchantProcessorSimulator' stamp: 'SebastianGarbi 6/5/2013 18:54'!
merchantProcesorOk
	debitExcecutionBlock := [ :aCC :anAmount |
		true.
		] .
	^self
	! !

!EditorialTest methodsFor: 'merchantProcessorSimulator' stamp: 'SebastianGarbi 6/5/2013 18:48'!
merchantProcesorWithAllCreditCardsWithoutMoney
	debitExcecutionBlock := [ :aCC :anAmount |
		self error: Cashier CreditCardWithoutMoneyMessage .
		] .
	^self
	! !

!EditorialTest methodsFor: 'merchantProcessorSimulator' stamp: 'SebastianGarbi 6/5/2013 18:44'!
merchantProcesorWithAllStolenCreditCards
	debitExcecutionBlock := [ :aCC :anAmount |
		self error: Cashier CreditCardStolenMessage.
		] .
	^self
	! !

!EditorialTest methodsFor: 'libroinstances' stamp: 'ebastian 6/3/2013 20:27'!
otroLibro
	^'Libro3'.! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 5/27/2013 21:09'!
test01CarritoShouldBeEmptyAfterCreation
	self assert: (self carrito isEmpty). ! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 6/3/2013 18:43'!
test02CarritoMustHaveABookAfterAdding
	|unCarrito unLibro unNumero unCatalogo|
	unLibro := self libro.
	unCatalogo := self catalog .
	unCatalogo at: unLibro put: 1.
	unCarrito := self carrito: unCatalogo.
	unNumero := 1.
	
	unCarrito add:  unNumero of: unLibro . 
	self deny:  (unCarrito ) isEmpty. 
	self assert:  (unCarrito includes: unLibro). 
	self assert:  ((unCarrito amountOf: unLibro) = unNumero).! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 6/3/2013 18:44'!
test03CanIncreaseBookQuantity
	|unCarrito unLibro unNumero unCatalogo |
	unLibro := self libro.
	unCatalogo := self catalog  .
	unCatalogo at: unLibro put: 12.
	unCarrito := self carrito: unCatalogo.
	unNumero := 1.
	
	
	
	
	
	unCarrito add: unNumero of: unLibro   .
	unCarrito add: unNumero of: unLibro   .

	 
	self assert:  ((unCarrito amountOf: unLibro) = (unNumero * 2)).! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 6/3/2013 18:45'!
test04CanAddDifferentBooks
	|unCarrito unLibro otroLibro unNumero unCatalogo |
	unLibro := self libro.
	otroLibro := self otroLibro.
	
	unCatalogo := self catalog  .
	unCatalogo at: unLibro put: 12.
	unCatalogo at: otroLibro put: 13.
	unCarrito := self carrito: unCatalogo.
	unNumero := 1.
	
	
	
	unCarrito add: unNumero of: unLibro  .
	unCarrito add: unNumero of: otroLibro  .
	
	
	 
	self assert: (unCarrito includes: unLibro).
	self assert: (unCarrito includes: otroLibro).! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 6/3/2013 18:45'!
test05AddingDifferentBooksRespectQuantities
	|unCarrito unLibro otroLibro unNumero otroNumero unCatalogo |
	unLibro := self libro.
	otroLibro := self otroLibro.
	
	unCatalogo := self catalog  .
	unCatalogo at: unLibro  put: 12.
	unCatalogo at: otroLibro put: 12.
	unCarrito := self carrito: unCatalogo.

	
	
	unNumero := 5.
	otroNumero := 4.
	
	unCarrito add: unNumero of: unLibro  .
	unCarrito add: otroNumero of: otroLibro  .
	
	
	
	 
	self assert: (unCarrito amountOf: unLibro ) = unNumero .
	self assert: (unCarrito amountOf: otroLibro) = otroNumero .
	
	self assert: unCarrito size = (unNumero + otroNumero ).! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 6/3/2013 18:46'!
test06CarritoCanOnlyTakeCatalogBooks
	|unCarrito|
	unCarrito := self carrito .
	self should: [unCarrito add: self libroDeOtroCatalogo. self fail.] raise: Error withExceptionDo: [ :anError | self assert: anError  messageText  = Carrito invalidElementMessage .  
	self assert:  unCarrito isEmpty ].
	
	
	
! !

!EditorialTest methodsFor: '02- Cashier' stamp: 'SebastianGarbi 6/5/2013 18:56'!
test07CashierDontSellAnEmptyCart
	| aCC aCashier aCatalog aCart |
	aCatalog := self emptyCatalog.
	aCC := CreditCard newName: 'juan perez' ccNumber: 128 expiration: Date today month.
	aCashier := self cashier: aCatalog.
	aCart := self carrito: aCatalog.
	self
		should: [ aCashier sellProducts: aCart withThisCreditCard: aCC withThisMP: self  merchantProcesorFail ]
		raise: Error
		withExceptionDo: [ :anError | 
			self assert: anError messageText = Cashier noProductsInCartMessage.
			self assert: aCart isEmpty ]! !

!EditorialTest methodsFor: '02- Cashier' stamp: 'SebastianGarbi 6/5/2013 18:51'!
test08ASellWithanInvalidCreditCardShouldRaiseAnError
	| aCashier aCatalog aCart unLibro aCC1 aCC2 aCC3 |
	unLibro := self libro.
	aCatalog := self emptyCatalog.
	aCatalog at: unLibro put: 10.
	aCC1 := CreditCard newName: '' ccNumber: 123 expiration: Date today month.
	aCC2 := CreditCard newName: 'fruta' ccNumber: 0 expiration: Date today month.
	aCC3 := CreditCard newName: 'frutita' ccNumber: 123 expiration: Date today month previous.
	aCashier := self cashier: Date today.
	aCart := self carrito: aCatalog.
	aCart add: 1 of: unLibro.
	self
		should: [ 
			aCashier sellProducts: aCart withThisCreditCard: aCC1 withThisMP: self merchantProcesorFail.
			self fail ]
		raise: Error
		withExceptionDo: [ :anError | self assert: anError messageText = Cashier invalidCreditCardMessage ].
	self
		should: [ 
			aCashier sellProducts: aCart withThisCreditCard: aCC2 withThisMP: self merchantProcesorFail.
			self fail ]
		raise: Error
		withExceptionDo: [ :anError | self assert: anError messageText = Cashier invalidCreditCardMessage ].
	self
		should: [ 
			aCashier sellProducts: aCart withThisCreditCard: aCC3 withThisMP: self merchantProcesorFail.
			self fail ]
		raise: Error
		withExceptionDo: [ :anError | self assert: anError messageText = Cashier invalidCreditCardMessage ].
	self assert: aCashier salesBook isEmpty! !

!EditorialTest methodsFor: '02- Cashier' stamp: 'SebastianGarbi 6/5/2013 18:53'!
test09aCashierShouldCreateASaleWithAValidCreditCard
	| aCart aCatalog aCashier aCreditCard sum|
	"un catalogo con un libro"
	aCatalog := self catalog.
	aCatalog at: self libro put: 2.	
	
	"un carrito con un libro del catalogo"
	aCart := self carrito: aCatalog.
	aCart add: self libro.	
		
	"una tarjeta de credito valida"
	aCreditCard := CreditCard newName: 'dueoNombre' ccNumber: 123 expiration: Date today month.	
	
	"un cajero"
	aCashier := self cashier: Date today.
	
	aCashier sellProducts: aCart withThisCreditCard: aCreditCard withThisMP: self merchantProcesorOk.
	
	self deny: aCashier salesBook isEmpty.
	self assert: aCashier salesBook first = (aCatalog at: self libro).
	
	sum := 0.
	aCashier salesBook do: [ :aSale | sum := sum + 1 ].
	self assert:  (sum = 1).
	



! !

!EditorialTest methodsFor: '02- Cashier' stamp: 'SebastianGarbi 6/5/2013 18:46'!
test10aCashierShouldReturnAnErrorWithAStolenCreditCard
	| aCart aCatalog aCashier aCreditCard |
	"un catalogo con un libro"
	aCatalog := self catalog.
	aCatalog at: self libro put: 2.	
	
	"un carrito con un libro del catalogo"
	aCart := self carrito: aCatalog.
	aCart add: self libro.	
		
	"una tarjeta de credito valida"
	aCreditCard := CreditCard newName: 'dueoNombre' ccNumber: 123 expiration: Date today month.	
	
	"un cajero"
	aCashier := self cashier: Date today.
	
	self should: [ aCashier sellProducts: aCart withThisCreditCard: aCreditCard withThisMP: self merchantProcesorWithAllStolenCreditCards.
					self fail ]
		raise:  Error 
		withExceptionDo:  [ :anError | self assert: anError messageText = Cashier CreditCardStolenMessage ].
	
	self assert: aCashier salesBook isEmpty.
		



! !

!EditorialTest methodsFor: '02- Cashier' stamp: 'ebastian 6/4/2013 22:26'!
test11aCashierShouldReturnAnErrorWithACreditCardWithoutMoney
	| aCart aCatalog aCashier aCreditCard |
	"un catalogo con un libro"
	aCatalog := self catalog.
	aCatalog at: self libro put: 2.	
	
	"un carrito con un libro del catalogo"
	aCart := self carrito: aCatalog.
	aCart add: self libro.	
		
	"una tarjeta de credito valida"
	aCreditCard := CreditCard newName: 'dueoNombre' ccNumber: 123 expiration: Date today month.	
	
	"un cajero"
	aCashier := self cashier: Date today.
	
	self should: [ aCashier sellProducts: aCart withThisCreditCard: aCreditCard withThisMP: self merchantProcesorWithAllCreditCardsWithoutMoney.
					self fail ]
		raise:  Error 
		withExceptionDo:  [ :anError | self assert: anError messageText = Cashier CreditCardWithoutMoneyMessage ].
	
	self assert: aCashier salesBook isEmpty.
		



! !

!EditorialTest methodsFor: '02- Cashier' stamp: 'SebastianGarbi 6/5/2013 18:49'!
test99aCashierKnowsHowToCalculeASellAmount

	|unCarrito unLibro otroLibro unNumero otroNumero unCatalogo aCashier |
	unLibro := self libro.
	otroLibro := self otroLibro.
	
	unCatalogo := self catalog  .
	unCatalogo at: unLibro  put: 12.
	unCatalogo at: otroLibro put: 13.
	unCarrito := self carrito: unCatalogo.

	
	
	unNumero := 5.
	otroNumero := 4.
	
	unCarrito add: unNumero of: unLibro  .
	unCarrito add: otroNumero of: otroLibro  .
	aCashier :=  self cashier: Date today.
	
	
	self assert: ((unNumero * 12) + (otroNumero * 13) =  (aCashier calculateCartValue: unCarrito )) 
	
	! !
